      FUNCTION CUBEVL(XREQRD)

C     *************************************************************************
C
C     CUBEVL
C     ======
C
C     AUTHOR
C     ------
C     R.S.CANT, AFTER NUMERICAL RECIPES
C
C     CHANGE RECORD
C     -------------
C     23-JUL-1990: CREATED
C     22-JUL-1994: RSC MODIFIED FOR NEW RUNS AT CTR 1994
C
C     DESCRIPTION
C     -----------
C     EVALUATES THE SPLINE FROM THE KNOTS
C
C     *************************************************************************

      IMPLICIT NONE
      
C     GLOBAL DATA
      REAL*8 XKNOTS(261),YKNOTS(261),SKNOTS(261)
      INTEGER NKNOTS
      COMMON/SPLINE/XKNOTS,YKNOTS,SKNOTS,NKNOTS

C     ARGUMENTS
      REAL*8 CUBEVL,XREQRD

C     LOCAL DATA
      REAL*8 DELTAX,ACOEFF,BCOEFF
      INTEGER KCOUNT,KLO,KHI

C     BEGIN
C     =====

C     BISECTION
      KLO = 1
      KHI = NKNOTS

1000  CONTINUE
        IF(KHI-KLO.GT.1)THEN
          KCOUNT = (KHI+KLO)/2
          IF(XKNOTS(KCOUNT).GT.XREQRD)THEN
            KHI = KCOUNT
          ELSE
            KLO = KCOUNT
          ENDIF
          GOTO 1000
        ENDIF
C     END OF BISECTION LOOP

      DELTAX = XKNOTS(KHI) - XKNOTS(KLO)
      ACOEFF = (XKNOTS(KHI)-XREQRD)/DELTAX
      BCOEFF = (XREQRD-XKNOTS(KLO))/DELTAX

      CUBEVL = ACOEFF*YKNOTS(KLO) + BCOEFF*YKNOTS(KHI)
     1       +((ACOEFF**3-ACOEFF)*SKNOTS(KLO)
     2       +(BCOEFF**3-BCOEFF)*SKNOTS(KHI))*(DELTAX**2)/6.

      RETURN
      END    
