      SUBROUTINE CUBKNT(XARRAY,YARRAY,NARRAY)

C     *************************************************************************
C
C     CUBKNT
C     ======
C
C     AUTHOR
C     ------
C     R.S.CANT, AFTER NUMERICAL RECIPES
C
C     CHANGE RECORD
C     -------------
C     23-JUL-1990: CREATED
C     22-JUL-1994: RSC MODIFIED FOR NEW RUNS AT CTR 1994
C
C     DESCRIPTION
C     -----------
C     EVALUATES THE KNOTS FOR A SPLINE FIT TO MAX. 261 DATA POINTS
C
C     *************************************************************************

      IMPLICIT NONE
      
C     GLOBAL DATA
      REAL*8 XKNOTS(261),YKNOTS(261),SKNOTS(261)
      INTEGER NKNOTS
      COMMON/SPLINE/XKNOTS,YKNOTS,SKNOTS,NKNOTS

C     ARGUMENTS
      REAL*8 XARRAY(NARRAY),YARRAY(NARRAY)
      INTEGER NARRAY

C     LOCAL DATA
      REAL*8 WORKSP(261)
      REAL*8 SUPPER,WUPPER,SIG,PVAL
      INTEGER ICOUNT


C     BEGIN
C     =====

C     SET NATURAL BCS
      SKNOTS(1) = 0.0
      WORKSP(1) = 0.0
      SUPPER = 0.0
      WUPPER = 0.0

C     DECOMPOSITION LOOP OF TRID ALGORITHM
      DO 1000 ICOUNT = 2,NARRAY-1
        SIG = (XARRAY(ICOUNT)-XARRAY(ICOUNT-1))
     1       /(XARRAY(ICOUNT+1)-XARRAY(ICOUNT-1))
        PVAL = SIG*SKNOTS(ICOUNT-1)+2.
        SKNOTS(ICOUNT) = (SIG-1.)/PVAL
        WORKSP(ICOUNT) = (6.*((YARRAY(ICOUNT+1)-YARRAY(ICOUNT))
     1                       /(XARRAY(ICOUNT+1)-XARRAY(ICOUNT))
     2                       -(YARRAY(ICOUNT)-YARRAY(ICOUNT-1))
     3                       /(XARRAY(ICOUNT)-XARRAY(ICOUNT-1)))
     4                       /(XARRAY(ICOUNT+1)-XARRAY(ICOUNT-1))
     5                       -SIG*WORKSP(ICOUNT-1))/PVAL
1000  CONTINUE

      SKNOTS(NARRAY) = (WUPPER-SUPPER*WORKSP(NARRAY-1))
     1                /(SUPPER*SKNOTS(NARRAY-1)+1.)

C     BACKSUBSTITUTION
      DO 2000 ICOUNT = NARRAY-1,1,-1
        SKNOTS(ICOUNT) = SKNOTS(ICOUNT)*SKNOTS(ICOUNT+1)+WORKSP(ICOUNT)
2000  CONTINUE

C     FILL THE COMMON BLOCK
      NKNOTS = NARRAY
      DO 3000 ICOUNT = 1,NKNOTS
        XKNOTS(ICOUNT) = XARRAY(ICOUNT)
        YKNOTS(ICOUNT) = YARRAY(ICOUNT)
3000  CONTINUE

      RETURN
      END    
