      PROGRAM MMCHCK

C     *************************************************************************

C     MMCHCK
C     ======
C
C     AUTHOR
C     ------
C     R.S.CANT  --  CAMBRIDGE UNIVERSITY ENGINEERING DEPARTMENT
C
C     CHANGE RECORD
C     -------------
C     22-SEP-2012:  CREATED
C
C     DESCRIPTION
C     -----------
C     DIFFUSION PREPROCESSOR PPDIFF
C     CHECKS MONCHICK--MASON COLLISION INTEGRAL DATA
C
C     *************************************************************************


C     PARAMETERS
C     ==========
      INTEGER NDVMAX,NTVMAX
      PARAMETER(NDVMAX = 8, NTVMAX = 40)
      INTEGER NCDATA,NCCGNU
      PARAMETER(NCDATA = 1, NCCGNU = 7)


C     LOCAL DATA
C     ==========
      DOUBLE PRECISION OMEG11(NDVMAX,NTVMAX),OMEG22(NDVMAX,NTVMAX)
      DOUBLE PRECISION ASTAR(NDVMAX,NTVMAX),ACHECK(NDVMAX,NTVMAX)
      DOUBLE PRECISION TREDUC(NTVMAX)
      DOUBLE PRECISION DREDUC(NDVMAX)
      INTEGER IDVALS,ITVALS,NDVALS,NTVALS


C     BEGIN
C     =====

C     =========================================================================

C     READ THE DATA
      NDVALS = 8
C     READ OMEGA(1,1)*
      OPEN(UNIT=NCDATA,FILE='omega11.dat',FORM='FORMATTED')
      READ(NCDATA,*)(DREDUC(IDVALS),IDVALS = 1, NDVALS)
      WRITE(6,'(7X,F8.5,7F9.4)')(DREDUC(IDVALS),IDVALS = 1, NDVALS)

      ITVALS = 1
1000  CONTINUE
        READ(NCDATA,*,END=1010)TREDUC(ITVALS),
     +                   (OMEG11(IDVALS,ITVALS),IDVALS = 1, NDVALS)
        WRITE(6,'(F7.1,F8.5,7F9.4)')TREDUC(ITVALS),
     +              (OMEG11(IDVALS,ITVALS),IDVALS = 1, NDVALS)
        ITVALS = ITVALS + 1
        GOTO 1000
C     END OF LOOP 1000
1010  CONTINUE
      NTVALS = ITVALS - 1
C      IF(TREDUC(NTVALS).GT.100.0)NTVALS = NTVALS - 1
      WRITE(6,'(I5)')NTVALS

C     READ OMEGA(2,2)*
      OPEN(UNIT=NCDATA,FILE='omega22.dat',FORM='FORMATTED')
      READ(NCDATA,*)(DREDUC(IDVALS),IDVALS = 1, NDVALS)
      WRITE(6,'(7X,F8.5,7F9.4)')(DREDUC(IDVALS),IDVALS = 1, NDVALS)

      ITVALS = 1
2000  CONTINUE
        READ(NCDATA,*,END=2020)TREDUC(ITVALS),
     +                   (OMEG22(IDVALS,ITVALS),IDVALS = 1, NDVALS)
        WRITE(6,'(F7.1,F8.5,7F9.4)')TREDUC(ITVALS),
     +              (OMEG22(IDVALS,ITVALS),IDVALS = 1, NDVALS)
        ITVALS = ITVALS + 1
        GOTO 2000
C     END OF LOOP 1000
2020  CONTINUE
      NTVALS = ITVALS - 1
C      IF(TREDUC(NTVALS).GT.100.0)NTVALS = NTVALS - 1
      WRITE(6,'(I5)')NTVALS

C     EVALUATE THE RATIO
      DO IDVALS = 1, NDVALS
        DO ITVALS = 1, NTVALS

          ACHECK(IDVALS,ITVALS) =
     +          OMEG22(IDVALS,ITVALS)/OMEG11(IDVALS,ITVALS)

        ENDDO
      ENDDO


C     READ A*
      OPEN(UNIT=NCDATA,FILE='astar.dat',FORM='FORMATTED')
      READ(NCDATA,*)(DREDUC(IDVALS),IDVALS = 1, NDVALS)
      WRITE(6,'(7X,F8.5,7F9.4)')(DREDUC(IDVALS),IDVALS = 1, NDVALS)

      ITVALS = 1
3000  CONTINUE
        READ(NCDATA,*,END=3030)TREDUC(ITVALS),
     +                   (ASTAR(IDVALS,ITVALS),IDVALS = 1, NDVALS)
        WRITE(6,'(F7.1,F8.5,7F9.4)')TREDUC(ITVALS),
     +              (ASTAR(IDVALS,ITVALS),IDVALS = 1, NDVALS)
        ITVALS = ITVALS + 1
        GOTO 3000
C     END OF LOOP 3000
3030  CONTINUE
      NTVALS = ITVALS - 1
C      IF(TREDUC(NTVALS).GT.100.0)NTVALS = NTVALS - 1
      WRITE(6,'(I5)')NTVALS

C     =========================================================================

C     PRODUCE AN OUTPUT FILE
      OPEN(UNIT=NCCGNU,FILE='mmdata.res',FORM='FORMATTED')
      WRITE(NCCGNU,'(7X,F8.5,7F9.4)')(DREDUC(IDVALS),IDVALS = 1, NDVALS)
      DO ITVALS = 1,NTVALS-2

        WRITE(NCCGNU,'(F7.1,F8.4,7F9.3)')TREDUC(ITVALS+1),
     +                (ACHECK(IDVALS,ITVALS),IDVALS = 1, NDVALS)
        
      ENDDO
      CLOSE(NCCGNU)

C     =========================================================================


      STOP
      END
