      PROGRAM MMPLOT

C     *************************************************************************

C     MMPLOT
C     ======
C
C     AUTHOR
C     ------
C     R.S.CANT  --  CAMBRIDGE UNIVERSITY ENGINEERING DEPARTMENT
C
C     CHANGE RECORD
C     -------------
C     20-SEP-2012:  CREATED
C
C     DESCRIPTION
C     -----------
C     DIFFUSION PREPROCESSOR PPDIFF
C     PLOTS MONCHICK--MASON COLLISION INTEGRAL DATA
C
C     *************************************************************************


C     PARAMETERS
C     ==========
      INTEGER NDVMAX,NTVMAX
      PARAMETER(NDVMAX = 8, NTVMAX = 40)
      INTEGER NCCGNU
      PARAMETER(NCCGNU = 7)


C     LOCAL DATA
C     ==========
      DOUBLE PRECISION COLINT(NDVMAX,NTVMAX)
      DOUBLE PRECISION TREDUC(NTVMAX)
      DOUBLE PRECISION DREDUC(NDVMAX)
      INTEGER IDVALS,ITVALS,NDVALS,NTVALS


C     BEGIN
C     =====

C     =========================================================================

C     READ THE DATA FROM STANDARD INPUT
      NDVALS = 8
      READ(5,*)(DREDUC(IDVALS),IDVALS = 1, NDVALS)
      WRITE(6,'(7X,F8.5,7F9.4)')(DREDUC(IDVALS),IDVALS = 1, NDVALS)

      ITVALS = 1
1000  CONTINUE
        READ(5,*,END=1010)TREDUC(ITVALS),
     +                   (COLINT(IDVALS,ITVALS),IDVALS = 1, NDVALS)
        WRITE(6,'(F7.1,F8.5,7F9.4)')TREDUC(ITVALS),
     +              (COLINT(IDVALS,ITVALS),IDVALS = 1, NDVALS)
        ITVALS = ITVALS + 1
        GOTO 1000
C     END OF LOOP 1000
1010  CONTINUE
      NTVALS = ITVALS - 1
      IF(TREDUC(NTVALS).GT.100.0)NTVALS = NTVALS - 1
      WRITE(6,'(I5)')NTVALS

C     =========================================================================

C     PRODUCE A GNUPLOT FILE
      OPEN(UNIT = NCCGNU, FILE = 'mmdata.res', FORM= 'FORMATTED')
      DO IDVALS = 1, NDVALS

        DO ITVALS = 1, NTVALS - 12
          WRITE(NCCGNU,'(3(1PE12.4))')DREDUC(IDVALS),TREDUC(ITVALS),
     +                                COLINT(IDVALS,ITVALS)

        ENDDO
        WRITE(NCCGNU,*)

      ENDDO

      WRITE(NCCGNU,*)
      CLOSE(NCCGNU)

C     =========================================================================


      STOP
      END
