      PROGRAM GJTEST

C     *************************************************************************
C
C     GJTEST
C     ======
C
C     AUTHOR
C     ------
C     R.S.CANT  --  CAMBRIDGE UNIVERSITY ENGINEERING DEPARTMENT
C
C     CHANGE RECORD
C     -------------
C     13-OCT-2012:  CREATED
C      
C     DESCRIPTION
C     -----------
C     TESTS THE GAUSS-JORDAN LINEAR EQUATION SOLVER GAUSSJ
C
C     *************************************************************************


C     PARAMETERS
C     ==========
      DOUBLE PRECISION ZERO
      PARAMETER(ZERO = 0.0D0)

      INTEGER NPHYS,MPHYS
      PARAMETER(NPHYS = 50, MPHYS = 10)


C     LOCAL DATA
C     ==========
      DOUBLE PRECISION AMATRX(NPHYS,NPHYS),BMATRX(NPHYS,MPHYS)
      DOUBLE PRECISION CMATRX(NPHYS,NPHYS),DMATRX(NPHYS,MPHYS)
      DOUBLE PRECISION EMATRX(NPHYS,NPHYS),FMATRX(NPHYS,MPHYS)
      INTEGER NSIZE,MSIZE
      INTEGER IC,JC,KC


C     BEGIN
C     =====

C     -------------------------------------------------------------------------

C     INTERACT TO GET THE MATRIX AND RHS VECTORS
      WRITE(6,*)'GJTEST'
      WRITE(6,*)
      WRITE(6,*)'Enter the problem size and the no. of RHS vectors'
      READ(5,*)NSIZE,MSIZE
      WRITE(6,*)
      WRITE(6,*)'Enter the matrix and the RHS vectors'
      DO IC = 1, NSIZE
        READ(5,*)(AMATRX(IC,JC),JC=1,NSIZE),(BMATRX(IC,KC),KC=1,MSIZE)
      ENDDO
      WRITE(6,*)

C     WRITE THEM OUT
      WRITE(6,*)'Matrix and RHS vectors'
      DO IC = 1, NSIZE
        WRITE(6,'(6(1PE12.4))')
     +       (AMATRX(IC,JC),JC=1,NSIZE),(BMATRX(IC,KC),KC=1,MSIZE)
      ENDDO
      WRITE(6,*)

C     -------------------------------------------------------------------------

C     COPY THE MATRICES
      DO JC = 1, NSIZE
        DO IC = 1, NSIZE
          CMATRX(IC,JC) = AMATRX(IC,JC)
        ENDDO
      ENDDO
      DO JC = 1, MSIZE
        DO IC = 1, NSIZE
          DMATRX(IC,JC) = BMATRX(IC,JC)
        ENDDO
      ENDDO

C     -------------------------------------------------------------------------

C     CALL THE ROUTINE
      CALL GAUSSJ(AMATRX,NSIZE,NPHYS,BMATRX,MSIZE,MPHYS)

C     -------------------------------------------------------------------------

C     WRITE THE OUTPUT
      WRITE(6,*)'Inverse matrix and solution vectors'
      DO IC = 1, NSIZE
        WRITE(6,'(6(1PE12.4))')
     +       (AMATRX(IC,JC),JC=1,NSIZE),(BMATRX(IC,KC),KC=1,MSIZE)
      ENDDO
      WRITE(6,*)

C     -------------------------------------------------------------------------

C     CHECK THE INVERSE
      DO JC = 1, NSIZE
        DO IC = 1, NSIZE

          EMATRX(IC,JC) = ZERO

        ENDDO
      ENDDO
      DO KC = 1, NSIZE
        DO JC = 1, NSIZE
          DO IC = 1, NSIZE

            EMATRX(IC,JC) = EMATRX(IC,JC)
     +                    + AMATRX(IC,KC)*CMATRX(KC,JC)

          ENDDO
        ENDDO
      ENDDO
  
C     -------------------------------------------------------------------------

C     WRITE THE OUTPUT
      WRITE(6,*)'Check of inverse matrix no 1'
      DO IC = 1, NSIZE
        WRITE(6,'(6(1PE12.4))')(EMATRX(IC,JC),JC=1,NSIZE)
      ENDDO
      WRITE(6,*)

C     -------------------------------------------------------------------------

C     CHECK THE INVERSE
      DO JC = 1, NSIZE
        DO IC = 1, NSIZE

          EMATRX(IC,JC) = ZERO

        ENDDO
      ENDDO
      DO KC = 1, NSIZE
        DO JC = 1, NSIZE
          DO IC = 1, NSIZE

            EMATRX(IC,JC) = EMATRX(IC,JC)
     +                    + CMATRX(IC,KC)*AMATRX(KC,JC)

          ENDDO
        ENDDO
      ENDDO
  
C     -------------------------------------------------------------------------

C     WRITE THE OUTPUT
      WRITE(6,*)'Check of inverse matrix no 2'
      DO IC = 1, NSIZE
        WRITE(6,'(6(1PE12.4))')(EMATRX(IC,JC),JC=1,NSIZE)
      ENDDO
      WRITE(6,*)

C     -------------------------------------------------------------------------

C     CHECK THE SOLUTION
      DO JC = 1, MSIZE
        DO IC = 1, NSIZE

          FMATRX(IC,JC) = ZERO

        ENDDO
      ENDDO
      DO KC = 1, NSIZE
        DO JC = 1, MSIZE
          DO IC = 1, NSIZE

            FMATRX(IC,JC) = FMATRX(IC,JC)
     +                    + CMATRX(IC,KC)*BMATRX(KC,JC)

          ENDDO
        ENDDO
      ENDDO
  
C     -------------------------------------------------------------------------

C     WRITE THE OUTPUT
      WRITE(6,*)'Check of solution'
      DO IC = 1, NSIZE
        WRITE(6,'(6(1PE12.4))')(FMATRX(IC,JC),JC=1,MSIZE)
      ENDDO
      WRITE(6,*)

C     -------------------------------------------------------------------------


      STOP
      END
