      SUBROUTINE OUTMOL
 
C     *************************************************************************
C
C     OUTMOL
C     ======
C
C     AUTHOR
C     ------
C     R.S.CANT  --  CAMBRIDGE UNIVERSITY ENGINEERING DEPARTMENT
C
C     CHANGE RECORD
C     -------------
C     06-OCT-2012:  CREATED
C      
C     DESCRIPTION
C     -----------
C     WRITES OUT THE MOLECULAR TRANSPORT DATA FOR PPDIFF
C
C     *************************************************************************


C     GLOBAL DATA
C     ===========
C     -------------------------------------------------------------------------
      INCLUDE 'com_diffin.h'
      INCLUDE 'com_ppdcom.h'
C     -------------------------------------------------------------------------


C     LOCAL DATA
C     ==========
      INTEGER ISPEC,JSPEC
      INTEGER ICOEFF
 
      CHARACTER*50 ERRSTR


C     BEGIN
C     =====

C     =========================================================================

      OPEN(UNIT=NCOUTP,FILE=FNOUTP,STATUS='UNKNOWN',FORM='FORMATTED',
     +     ERR=1010)

C     =========================================================================

C     HEADER
      WRITE(NCOUTP,*)'*****************************'
      WRITE(NCOUTP,*)'*                           *'
      WRITE(NCOUTP,*)'*  Output file from ppdiff  *'
      WRITE(NCOUTP,*)'*                           *'
      WRITE(NCOUTP,*)'*****************************'

C     =========================================================================

C     SPECIES LIST
      WRITE(NCOUTP,*)'Species list:'
      WRITE(NCOUTP,'(I5)')NSPEC
      DO ISPEC = 1, NSPEC
        WRITE(NCOUTP,'(I5,3X,A)')ISPEC,SPCSYM(ISPEC)
      ENDDO

C     SPECIES DATA
      WRITE(NCOUTP,*)'Species molecular transport data:'
      WRITE(NCOUTP,'(2(1PE12.4))')PREFGB,TREFGB
      DO ISPEC = 1,NSPEC
        WRITE(NCOUTP,'(I5)')ISPEC
        WRITE(NCOUTP,'(I5)')NCOVIS
        WRITE(NCOUTP,'(5(1PE15.7))')
     +       (VISCCO(ICOEFF,ISPEC),ICOEFF=1,NCOVIS)
        WRITE(NCOUTP,'(I5)')NCOCON
        WRITE(NCOUTP,'(5(1PE15.7))')
     +       (CONDCO(ICOEFF,ISPEC),ICOEFF=1,NCOCON)
        WRITE(NCOUTP,'(I5)')NCODIF
        DO JSPEC = 1,ISPEC
          WRITE(NCOUTP,'(5(1PE15.7))')
     +         (DIFFCO(ICOEFF,JSPEC,ISPEC),ICOEFF=1,NCODIF)
        ENDDO
        WRITE(NCOUTP,'(I5)')NCOTDR
        DO JSPEC = 1,ISPEC-1
          WRITE(NCOUTP,'(5(1PE15.7))')
     +         (TDRCCO(ICOEFF,JSPEC,ISPEC),ICOEFF=1,NCOTDR)
        ENDDO
      ENDDO

C     =========================================================================

      WRITE(NCOUTP,*)'End of file'
      CLOSE(NCOUTP)

C     =========================================================================

C     FILENAME ERROR HANDLER
      GOTO 1020
1010  ERRSTR = 'opening output file:'
      CALL ERHAND(ERRSTR,IEFATL)
1020  CONTINUE
C     END OF FILENAME ERROR HANDLER

C     =========================================================================


      RETURN
      END
